#include "ws.h"
#include "scene.h"
#include <string.h>

#include <glib.h>

static gboolean
quit (gpointer data)
{
    GMainLoop *loop = data;

    g_main_loop_quit (loop);
    
    return FALSE;
}

#if 0
static void
on_damage (WsDrawable *drawable,
	   gpointer data)
{
    WsRegion *region = ws_drawable_undamage (drawable);

    g_print ("damaged root\n");
    
    ws_region_unref (region);
}
#endif

static gboolean
party_on (gpointer data)
{
    scene_graph_start_animation (data);
}

int
main ()
{
    GMainLoop *loop = g_main_loop_new (NULL, 0);
    Ws *ws = ws_new (NULL);
    WsWindow *root = ws_screen_get_root_window (ws_screen_get_default (ws));
    GList *toplevels = ws_window_query_subwindows (root);
    SGCoord *coord = sg_coord_new_root (root);
    GList *list;

    g_assert (ws_init_damage (ws_drawable_get_ws ((WsDrawable *)root)));
    
    for (list = toplevels; list != NULL; list = list->next)
    {
	WsWindow *window = list->data;

	if (!ws_window_query_input_only (window))
	{	
	    SGVertex *v1, *v2, *v3, *v4;
	    WsRectangle rectangle;
	    GList *children = ws_window_query_subwindows (window);
	    GList *list;
	    gboolean use = FALSE;

	    for (list = children; list != NULL; list = list->next)
	    {
		WsWindow *child = list->data;
		
		char *title = ws_window_query_title (child);

		if (title &&
		    strcmp (title, "Compositing Test Window") == 0)
		{
		    use = TRUE;
		    break;
		}

		g_free (title);
	    }

	    g_list_free (children);
	    use = TRUE;
	    char *title = ws_window_query_title (window);
	    if (title && strcmp (title, "Desktop") == 0)
	    {
		g_print ("setting \n");
		use = TRUE;
	    }

	    if (use)
	    {
		ws_drawable_query_geometry ((WsDrawable *)window, &rectangle);
		
		v1 = sg_vertex_new (coord,
				    rectangle.x,
				    rectangle.y);
		v2 = sg_vertex_new (coord,
				    rectangle.x + rectangle.width,
				    rectangle.y);
		v3 = sg_vertex_new (coord,
				    rectangle.x + rectangle.width,
				    rectangle.y + rectangle.height);
		v4 = sg_vertex_new (coord,
				    rectangle.x,
				    rectangle.y + rectangle.height);

		sg_coord_add_window (coord, v1, v2, v3, v4, window);
	    }
	}
    }

    g_timeout_add (160000, quit, loop);

    g_timeout_add (20000, party_on, coord);
    
    g_main_loop_run (loop);
    
    return 0;
}
