#include <glib.h>
#include <GL/gl.h>
#include "node.h"
#include "translation.h"

static void
translation_compute_extents (Node *node,
			     Extents *extents)
{
    extents->x = 0.0;
    extents->y = 0.0;
    extents->z = 0.0;
    extents->width = 1.0;
    extents->height = 1.0;
    extents->depth = 1.0;
}

static void
translation_render (Node *node)
{
    Translation *translation = (Translation *)node;
    GList *list;
    GLboolean depth_mask;
    gdouble depth;
    
    glPushMatrix();

    glTranslatef (translation->x,
		  translation->y,
		  translation->z);

    translation->child->render (translation->child);

    glPopMatrix();
}

Translation *
translation_new (Node *child)
{
    Translation *translation = g_new0 (Translation, 1);

    translation->node.render = translation_render;
    translation->node.compute_extents = translation_compute_extents;

    translation->x = 0.0;
    translation->y = 0.0;
    translation->z = 0.0;

    translation->child = child;
    
    return translation;
}

void
translation_set_translation (Translation *translation,
			  gdouble	     x,
			  gdouble	     y,
			  gdouble      z)
{
    translation->x = x;
    translation->y = y;
    translation->z = z;
}

