#include "wsint.h"

WsPixmap *
pixmap_new (Ws *ws,
	    XID xid)
{
    WsPixmap *pixmap = g_new0 (WsPixmap, 1);

    _ws_drawable_init (&(pixmap->drawable), ws, xid);
    
    g_assert (xid == pixmap->drawable.xid);
    
    return pixmap;
}

WsPixmap *
ws_pixmap_new (WsDrawable *drawable,
	       int	   width,
	       int	   height,
	       int	   depth)
{
    Pixmap pixmap;
    Display *xdisplay = drawable->ws->xdisplay;

    pixmap = XCreatePixmap (xdisplay, drawable->xid, width, height, depth);

    return pixmap_new (drawable->ws, drawable->xid);
}


WsPixmap *
_ws_pixmap_ensure (Ws		*ws,
		   XID		 xid)
{
    WsPixmap *pixmap = g_hash_table_lookup (ws->xresources, (gpointer)xid);

    if (!pixmap)
	pixmap = pixmap_new (ws, xid);

    return pixmap;
}

void
ws_pixmap_free (WsPixmap *pixmap)
{
    XFreePixmap (pixmap->drawable.ws->xdisplay, pixmap->drawable.xid);
    /* FIXME */
}
