#include "wsint.h"

/* Mostly Cut and paste from GDK */

gboolean
ws_rectangle_intersect (WsRectangle *src1,
			WsRectangle *src2,
			WsRectangle *dest)
{
    gint dest_x, dest_y;
    gint dest_w, dest_h;
    gint return_val;
    
    g_return_val_if_fail (src1 != NULL, FALSE);
    g_return_val_if_fail (src2 != NULL, FALSE);
    
    return_val = FALSE;
    
    dest_x = MAX (src1->x, src2->x);
    dest_y = MAX (src1->y, src2->y);
    dest_w = MIN (src1->x + src1->width, src2->x + src2->width) - dest_x;
    dest_h = MIN (src1->y + src1->height, src2->y + src2->height) - dest_y;
    
    if (dest_w > 0 && dest_h > 0)
    {
	if (dest)
	{
	    dest->x = dest_x;
	    dest->y = dest_y;
	    dest->width = dest_w;
	    dest->height = dest_h;
	}

	return_val = TRUE;
    }
    else
    {
	if (dest)
	{
	    dest->width = 0;
	    dest->height = 0;
	}
    }
    
    return return_val;
}
